/******************************************************************************

	digest.c

	
*/

#include "md5.h"
#include "pic_string.h"


/*-----------------------------------------------------------------------------
	MD5 Digest
-----------------------------------------------------------------------------*/
#define HASH_LEN	16

static void CvtHex(uchar *hash_bin,char *hash_asc)
{
	unsigned short i;
	unsigned char	j;

	for(i=0;i<HASH_LEN;i++){
		j=(hash_bin[i]>>4)&0xf;
		if(j<=9)
			hash_asc[i*2]=(j+'0');
		else
			hash_asc[i*2]=(j+'a'-10);
		j=hash_bin[i]&0xf;
		if(j<=9)
			hash_asc[i*2+1]=(j+'0');
		else
			hash_asc[i*2+1]=(j+'a'-10);
	}
	hash_asc[HASH_LEN*2]='\0';
}

static char response[HASH_LEN *2 +1];
char *digest_calc_response(char *sip_id,char *realm, char *sip_pswrd,
	char *method, char *uri, char *nonce)
{
	unsigned char hash_bin[HASH_LEN];
	char	HA1[HASH_LEN * 2 +1];
	char	HA2[HASH_LEN * 2 +1];
	md5_ctx	c;


	md5_init(&c);
	md5_update(&c, (uchar *)sip_id, (ulong)strlen(sip_id));
	md5_update(&c, (uchar *)":", 1);
	md5_update(&c, (uchar *)realm, (ulong)strlen(realm));
	md5_update(&c, (uchar *)":", 1);
	md5_update(&c, (uchar *)sip_pswrd, (ulong)strlen(sip_pswrd));
	md5_final(hash_bin, &c);
	CvtHex(hash_bin, HA1);

	md5_init(&c);
	md5_update(&c, (uchar *)method, (ulong)strlen(method));
	md5_update(&c, (uchar *)":", 1); 
	md5_update(&c, (uchar *)uri, (ulong)strlen(uri));
	md5_final(hash_bin, &c);
	CvtHex(hash_bin, HA2);

	md5_init(&c);
	md5_update(&c, (uchar *)HA1, 32);
	md5_update(&c, (uchar *)":", 1);
	md5_update(&c, (uchar *)nonce, (ulong)strlen(nonce));
	md5_update(&c, (uchar *)":", 1);
	md5_update(&c, (uchar *)HA2, 32);
	md5_final(hash_bin, &c);
	CvtHex(hash_bin, response);

	return response;
}

