/***************************************************************************

	File: main.c

	Copyright (C) 2012 S.Suwa <www.suwa-koubou.jp>


	IPphone is SIP IP softphone, for PIC/W5100.

***************************************************************************/

/** INCLUDES **************************************************************/
#include <p24FJ64GA002.h>
#include "typedef.h"
#include "pic_232.h"
#include "pic_print.h"
#include "pic_delay.h"
#include "pic_string.h"
#include "pic_timer.h"
#include "W5100.h"

#include "sysconf.h"
#include "message.h"
#include "sound.h"
#include "lcd.h"
#include "setup.h"
#include "key.h"
#include "ua.h"


/** CHIP CONFIGURATION ****************************************************/
_CONFIG1(JTAGEN_OFF & GCP_OFF & GWRP_OFF & BKBUG_OFF & COE_OFF & ICS_PGx1 &
		 FWDTEN_OFF & WINDIS_OFF & FWPSA_PR32 & WDTPS_PS1)
_CONFIG2(IESO_OFF & SOSCSEL_SOSC & WUTSEL_LEG & FNOSC_FRCPLL & FCKSM_CSDCMD & 
		 OSCIOFNC_OFF & IOL1WAY_OFF & I2C1SEL_PRI & POSCMOD_NONE)
 
/** DEFINITION ************************************************************/ 
#define	OFF		0
#define	ON		1

/** VARIABLES *************************************************************/ 

/** FUNCTION PROTOTYPE ****************************************************/


/*==========================================================================
	main
==========================================================================*/

int		main(void)
{
	// system initialize
	setup_network_information();
	system_initialize();

	// LAN initialize 
	w5100_initialize();

	// go SIP UA
	dispatch();

	return 0;
}

/*** end of main.c **********************************************************/
