/********************************************************************

	File: md5.h

*/

#ifndef __MD5_H
#define __MD5_H

#include "typedef.h"

/**
	MD5 context. 
 */
typedef struct {
        ulong state[4];    // state (ABCD)
        ulong count[2];    // number of bits, modulo 2^64 (lsb first)
        uchar  buffer[64];  // input buffer
      } md5_ctx;

extern void md5_init(md5_ctx *context);
extern void md5_update(md5_ctx *context, uchar *buffer, ulong length);
extern void md5_final(uchar result[16], md5_ctx *context);

#endif	// __md5_H
