/**************************************************************

	File: message.h

	Copyright (C) 2012 S.Suwa <www.suwa-koubou.jp>

*/

#ifndef	__MESSAGE_H
#define	__MESSAGE_H

// buffer size
#define	TEL_SIZE		16
#define	BRANCH_SIZE		20
#define	TAG_SIZE		12
#define	CALL_ID_SIZE	34
#define	AUTH_SIZE		200

extern	void	srand(int x);
extern	int		rand(void);

extern	int	 make_seq(void);
extern	char *make_branch(char *buf);
extern	char *make_tag(char *buf);
extern	char *make_call_id(char *buf);
extern	char *get_to_tag(void);
extern	void anlys_sdp(void);
extern	char *header_copy(char *orig, char *buf, char *hname);
extern	char *make_auth(char *buf, char *request);

extern	char *make_REGISTER_msg(char *branch, char *from_tag, char *to_tag, char *call_id, int cmdseq, char *auth);
extern	char *make_INVITE_msg(char *tel, char *branch, char *from_tag, char *to_tag, char *call_id, int cmdseq, char *auth);
extern	char *make_sdp(void);
extern	char *make_ACK_msg(char *tel, char *branch, int cmdseq);
extern	char *make_PRACK_msg(char *tel, char *branch, int cmdseq, int invite_cmdseq);
extern	char *make_CANCEL_msg(char *tel, char *branch, int cmdseq);
extern	char *make_BYE_msg(char *tel, char *branch, int cmdseq, int call_type);
extern	char *make_UPDATE_msg(char *tel, char *branch, int cmdseq, int call_type);
extern	char *make_request_msg(char *method, char *tel, char *branch, char *call_id, 
						char *from_tag, char *to_tag, int cmdseq, int invite_cmdseq,
						char *auth, int call_type);
extern	char *make_response_msg(int status_code);
extern	char *make_200OK_msg(int tmopt, int sender);

extern	char *make_100_msg(void);
extern	char *make_180_msg(void);
extern	char *make_200_msg(void);
extern	char *make_420_msg(void);
extern	char *make_422_msg(void);
extern	char *make_486_msg(void);
extern	char *make_487_msg(void);
extern	int	flg_184;

#endif // __MESSAGE_H

/*** end of message.h *****************************************/
